"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// src/utils/broken-named-exports.js
var broken_named_exports_default = {
  react: [
    "Children",
    "Component",
    "Fragment",
    "Profiler",
    "PureComponent",
    "StrictMode",
    "Suspense",
    "__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED",
    "cloneElement",
    "createContext",
    "createElement",
    "createFactory",
    "createRef",
    "forwardRef",
    "isValidElement",
    "lazy",
    "memo",
    "useCallback",
    "useContext",
    "useDebugValue",
    "useEffect",
    "useImperativeHandle",
    "useLayoutEffect",
    "useMemo",
    "useReducer",
    "useRef",
    "useState",
    "version"
  ],
  "react-dom": [
    "__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED",
    "createPortal",
    "findDOMNode",
    "flushSync",
    "hydrate",
    "render",
    "unmountComponentAtNode",
    "unstable_batchedUpdates",
    "unstable_createPortal",
    "unstable_renderSubtreeIntoContainer",
    "version"
  ],
  "react-is": ["isContextConsumer", "isValidElementType"]
};

// src/config.js
var import_node_path = __toESM(require("path"), 1);
var import_node_url = require("url");
var DIR_NAME = ".dvlp";
var TESTING = process.env.NODE_ENV === "dvlptest" || process.env.CI != void 0;
var VERSION = "15.0.0-beta.4";
var dirPath = import_node_path.default.resolve(DIR_NAME);
var versionDirPath = import_node_path.default.join(dirPath, VERSION);
var applicationLoaderURL = (0, import_node_url.pathToFileURL)(
  import_node_path.default.join(versionDirPath, "app-loader.mjs")
);
var bundleDirName = import_node_path.default.join(DIR_NAME, VERSION, "bundled");
var bundleDirPath = import_node_path.default.resolve(bundleDirName);
var bundleDirMetaPath = import_node_path.default.join(bundleDirPath, "__meta__.json");
var defaultPort = process.env.PORT ? Number(process.env.PORT) : 8080;
var electronDirPath = import_node_path.default.join(versionDirPath, "electron");
var electronEntryURL = (0, import_node_url.pathToFileURL)(
  import_node_path.default.join(electronDirPath, "electron-entry.cjs")
);
var config = {
  activePort: defaultPort,
  applicationLoaderURL,
  brokenNamedExportsPackages: broken_named_exports_default,
  bundleDirPath,
  bundleDirMetaPath,
  bundleDirName,
  defaultPort,
  directories: [],
  dirPath,
  dvlpDirPath: import_node_path.default.resolve(DIR_NAME),
  electronDirPath,
  electronEntryURL,
  esbuildTargetByExtension: {
    ".js": "js",
    ".mjs": "js",
    ".cjs": "js",
    ".json": "json",
    ".jsx": "jsx",
    ".ts": "ts",
    ".tsx": "tsx",
    ".mts": "ts",
    ".cts": "ts"
  },
  extensionsByType: {
    css: [".pcss", ".sass", ".scss", ".less", ".styl", ".stylus", ".css"],
    html: [
      ".nunjs",
      ".nunjucks",
      ".hbs",
      ".handlebars",
      ".dust",
      ".html",
      ".htm"
    ],
    js: [".ts", ".mts", ".cts", ".tsx", ".jsx", ".mjs", ".cjs", ".js", ".json"]
  },
  jsMimeTypes: {
    "application/javascript": ["js", "mjs", "cjs", "jsx", "ts", "tsx"]
  },
  latency: 50,
  maxAge: "10m",
  reloadEndpoint: "/dvlpreload",
  serverStartTimeout: TESTING ? 4e3 : 1e4,
  testing: TESTING,
  typesByExtension: {
    ".css": "css",
    ".pcss": "css",
    ".sass": "css",
    ".scss": "css",
    ".less": "css",
    ".styl": "css",
    ".stylus": "css",
    ".html": "html",
    ".htm": "html",
    ".nunjs": "html",
    ".nunjucks": "html",
    ".hbs": "html",
    ".handlebars": "html",
    ".dust": "html",
    ".js": "js",
    ".mjs": "js",
    ".cjs": "js",
    ".json": "js",
    ".jsx": "js",
    ".ts": "js",
    ".tsx": "js",
    ".mts": "js",
    ".cts": "js"
  },
  version: VERSION,
  versionDirPath
};
var config_default = config;

// src/electron-host/electron-entry.js
var import_node_crypto = __toESM(require("crypto"), 1);
var import_electron = __toESM(require("electron"), 1);
var import_node_fs2 = __toESM(require("fs"), 1);

// src/utils/is.js
var import_node_fs = __toESM(require("fs"), 1);
var import_node_util = __toESM(require("util"), 1);
var HAS_UTIL_IS_PROXY = import_node_util.default.types && import_node_util.default.types.isProxy !== void 0;
var RE_LOCALHOST = /localhost|127\.0\.0\.1/;
var realPath = "native" in import_node_fs.default.realpathSync && typeof import_node_fs.default.realpathSync.native === "function" ? import_node_fs.default.realpathSync.native : import_node_fs.default.realpathSync;
function isLocalhost(url) {
  return RE_LOCALHOST.test(url);
}
function isProxy(obj) {
  if (HAS_UTIL_IS_PROXY) {
    return import_node_util.default.types.isProxy(obj);
  } else {
    return obj instanceof Proxy;
  }
}

// src/utils/intercept-client-request.js
var import_node_http = __toESM(require("http"), 1);
var import_node_https = __toESM(require("https"), 1);
var clientRequestListeners = /* @__PURE__ */ new Set();
var originalHttpRequest = import_node_http.default.request;
var originalHttpGet = import_node_http.default.get;
var originalHttpsRequest = import_node_https.default.request;
var originalHttpsGet = import_node_https.default.get;
function interceptClientRequest(fn) {
  initInterceptClientRequest();
  clientRequestListeners.add(fn);
  return restoreClientRequest.bind(null, fn);
}
function initInterceptClientRequest() {
  if (!isProxy(import_node_http.default.request)) {
    import_node_http.default.request = new Proxy(import_node_http.default.request, {
      apply: clientRequestApplyTrap("http")
    });
    import_node_http.default.get = new Proxy(import_node_http.default.get, { apply: clientRequestApplyTrap("http") });
    import_node_https.default.request = new Proxy(import_node_https.default.request, {
      apply: clientRequestApplyTrap("https")
    });
    import_node_https.default.get = new Proxy(import_node_https.default.get, {
      apply: clientRequestApplyTrap("https")
    });
  }
}
function restoreClientRequest(fn) {
  clientRequestListeners.delete(fn);
  if (!clientRequestListeners.size) {
    import_node_http.default.request = originalHttpRequest;
    import_node_http.default.get = originalHttpGet;
    import_node_https.default.request = originalHttpsRequest;
    import_node_https.default.get = originalHttpsGet;
  }
}
function clientRequestApplyTrap(protocol) {
  return function apply(target, ctx, args) {
    if (clientRequestListeners.size > 0) {
      let [urlOrOptions, optionsOrCallback, callback] = args;
      let options;
      let url;
      if (typeof urlOrOptions === "string" || urlOrOptions instanceof URL) {
        url = new URL(urlOrOptions);
        options = optionsOrCallback;
      } else {
        url = new URL(getHrefFromRequestOptions(urlOrOptions, protocol));
        callback = optionsOrCallback;
        options = urlOrOptions;
      }
      if (notifyListeners(clientRequestListeners, url) === false) {
        return;
      }
      if (isLocalhost(url.hostname)) {
        url.protocol = "http:";
        target = target === originalHttpsGet || target === originalHttpGet ? originalHttpGet : originalHttpRequest;
      }
      options.protocol = url.protocol;
      options.host = url.host;
      options.hostname = url.hostname;
      options.port = url.port;
      options.path = `${url.href.replace(url.origin, "")}`;
      options.href = url.href;
      if (options.agent && options.agent instanceof import_node_http.default.Agent && options.agent.protocol === "https:" && isLocalhost(url.hostname)) {
        options.agent = new import_node_http.default.Agent(options.agent.options || {});
      }
      args = [url, options, callback];
    }
    return Reflect.apply(target, ctx, args);
  };
}
function getHrefFromRequestOptions(options, protocol) {
  if (options.href) {
    return options.href;
  }
  if (options.host == null) {
    options.host = "localhost";
  }
  let { host, path: path3, port } = options;
  if (!host.includes(":") && port != null) {
    host += `:${port}`;
  }
  return `${protocol}://${host}${path3}`;
}
function notifyListeners(listeners, url) {
  for (const listener of listeners) {
    if (listener(url) === false) {
      return false;
    }
  }
}

// src/utils/url.js
function isEqualSearchParams(params1, params2) {
  const keys1 = Array.from(params1.keys());
  const keys2 = Array.from(params2.keys());
  if (keys1.length !== keys2.length) {
    return false;
  }
  for (const key of keys1) {
    const values1 = params1.getAll(key);
    const values2 = params2.getAll(key);
    if (values1.length !== values2.length) {
      return false;
    }
    for (const value of values1) {
      if (!values2.includes(value)) {
        return false;
      }
    }
  }
  return true;
}

// src/electron-host/electron-entry.js
var import_node_path2 = __toESM(require("path"), 1);
var RE_DATA_URL = /^data:text\/html;([^,]+,)?/;
var originalLoadURL = import_electron.default.BrowserWindow.prototype.loadURL;
var origin;
var mocks;
import_electron.default.BrowserWindow.prototype.loadFile = function loadFile(filePath, options) {
  return originalLoadURL.call(this, new URL(filePath, origin).href);
};
import_electron.default.BrowserWindow.prototype.loadURL = function loadURL(url, options) {
  if (RE_DATA_URL.test(url)) {
    const [match, encoding] = RE_DATA_URL.exec(url);
    const encodedMarkup = url.replace(match, "");
    const markup = encoding === "base64," ? Buffer.from(encodedMarkup, "base64").toString("utf-8") : decodeURI(encodedMarkup);
    const hash = import_node_crypto.default.createHash("md5").update(markup).digest("hex");
    const filePath = import_node_path2.default.join(config_default.electronDirPath, `${hash}.html`);
    import_node_fs2.default.writeFileSync(filePath, markup, "utf-8");
    url = import_node_path2.default.relative(process.cwd(), filePath);
  }
  return originalLoadURL.call(this, new URL(url, origin).href);
};
process.on(
  "message",
  async (msg) => {
    var _a, _b;
    if (msg.type === "start") {
      origin = msg.origin;
      mocks = (_a = msg.mocks) == null ? void 0 : _a.map((mockData) => {
        mockData.originRegex = new RegExp(mockData.originRegex);
        mockData.pathRegex = new RegExp(mockData.pathRegex);
        mockData.search = new URLSearchParams(mockData.search);
        return mockData;
      });
      try {
        await import(msg.main);
        (_b = process.send) == null ? void 0 : _b.call(process, { type: "started" });
      } catch (err) {
        console.error(err);
        process.exit(1);
      }
    }
  }
);
interceptClientRequest((url) => {
  if (mocks) {
    for (const mock of mocks) {
      if (!mock.originRegex.test(url.origin) || !mock.ignoreSearch && mock.search && !isEqualSearchParams(url.searchParams, mock.search)) {
        continue;
      }
      if (mock.pathRegex.exec(url.pathname) != null) {
        const href = url.href;
        url.host = new URL(origin).host;
        url.search = `?dvlpmock=${encodeURIComponent(href)}`;
        break;
      }
    }
  }
  return true;
});
